/// <reference types="node" />
import { OutgoingHttpHeaders } from 'http';
import needle from 'needle';
import * as querystring from 'querystring';
export declare interface Global extends NodeJS.Global {
    ignoreUnknownCA: boolean;
}
export interface Payload {
    body?: needle.BodyData;
    url: string;
    headers?: OutgoingHttpHeaders;
    method: needle.NeedleHttpVerbs;
    qs?: querystring.ParsedUrlQueryInput;
    timeout?: number;
    family?: number;
}
interface SuccessResponse<T> {
    success: true;
    body: T;
}
export declare type FailedResponse = {
    success: false;
    errorCode: number;
    error: Error | undefined;
};
export declare function makeRequest<T = void>(payload: Payload, attempts?: number): Promise<SuccessResponse<T> | FailedResponse>;
export {};
